#include "KtoUpdate.h"
#include "KtoPruef.h"

int main(int argc, char *argv[])
{
  int choice, result;
  char user[17], pass[17], filename[13], blz[9], kto[11];
  char *stringresult;

  while (1) {
    printf("\n\n\n\tMomentan aktivierte Datendatei: %s\n", KtoUpdateGetCurrentFileName());
    printf("\n\t0. Ende\n");
    printf("\t1. Nachsehen am Update-Server\n");
    printf("\t2. Herunterladen vom Update-Server\n");
    printf("\t3. Entpacken eines lbp-Pakets\n");
    printf("\t4. Aktivieren der neuesten lbd-Datendatei\n");
    printf("\t5. Aktivieren einer bestimmten lbd-Datendatei\n");
    printf("\n\t6. Bankverbindungsprfung\n");
    printf("\n\tIhre Auswahl: ");
    if (scanf("%d", &choice)==1) {
      switch (choice) {
        case 0: printf("\n\tEnde von KtoTool.\n\n");
                return 0;
        case 1:
        case 2: printf("\n\tBenutzername: ");
                scanf("%s", user);
                printf("\tKennwort: ");
                scanf("%s", pass);
                if (choice==1) /* erst mal nur prfen */
                  stringresult=KtoUpdateServerCheck(user, pass);
                else /* also: (choice==2): gleich downloaden */
                  stringresult=KtoUpdateServerDownload(user, pass);
                printf("\tErgebnis: %s\n", stringresult);
                printf("\tWeitere Informationen: %s\n", KtoUpdateGetLastError());
                break;
        case 3: printf("\n\tDateiname: ");
                scanf("%s", filename);
                if (!strchr(filename, '.'))
                  strcat(filename, ".lbp");
                result=KtoUpdateUnpack(filename);
                printf("\tErgebnis: %d\n", result);
                printf("\tDas bedeutet: %s\n", KtoUpdateGetErrorMessage(result));
                printf("\tWeitere Informationen: %s\n", KtoUpdateGetLastError());
                break;
        case 4: result=KtoUpdateActivate("");
                printf("\tErgebnis: %d\n", result);
                printf("\tDas bedeutet: %s\n", KtoUpdateGetErrorMessage(result));
                printf("\tWeitere Informationen: %s\n", KtoUpdateGetLastError());
                break;
        case 5: printf("\n\tDateiname: ");
                scanf("%s", filename);
                if (!strchr(filename, '.'))
                  strcat(filename, ".lbd");
                result=KtoUpdateActivate(filename);
                printf("\tErgebnis: %d\n", result);
                printf("\tDas bedeutet: %s\n", KtoUpdateGetErrorMessage(result));
                printf("\tWeitere Informationen: %s\n", KtoUpdateGetLastError());
                break;
        case 6: printf("\n\tBankleitzahl: ");
                scanf("%s", blz);
                printf("\tKontonummer: ");
                scanf("%s", kto);
                result=KtoPruefTestBlzKto(blz, kto);
                printf("\n\tErgebnis: %d (%s)\n", result, KtoPruefGetErrorMessage(result));
                if (result>=0) { /* bank existiert */
                  printf("\tBankName58: %s\n", KtoPruefGetBankName58(blz));
                  printf("\tBankName20: %s\n", KtoPruefGetBankName20(blz));
                  printf("\tBankName27: %s\n", KtoPruefGetBankName27(blz));
                  printf("\tBankPlz: %s\n", KtoPruefGetBankPlz(blz));
                  printf("\tBankOrt: %s\n", KtoPruefGetBankOrt(blz));
                  printf("\tIban: %s\n", KtoPruefGetIban(blz, kto, 1));
                  printf("\tBic: %s\n", KtoPruefGetBic(blz));
                } /* if (result>=0): bank existiert */
                break;
        default: printf("Ungltige Eingabe!\n");
      } /* switch (choice) */
    } else /* also: (scanf("%d", &choice)!=1) */
      printf("Ungltige Eingabe!\n");
  } /* while (1) */
}
